#!/bin/bash
# SPDX-Version: 3.0
# SPDX-CreationInfo: 2025-06-17; WEIDNER, Marc S.; <msw@coresecret.dev>
# SPDX-ExternalRef: GIT https://git.coresecret.dev/msw/CISS.debian.installer.git
# SPDX-FileContributor: WEIDNER, Marc S.; Centurion Intelligence Consulting Agency
# SPDX-FileCopyrightText: 2024-2025; WEIDNER, Marc S.; <msw@coresecret.dev>
# SPDX-FileType: SOURCE
# SPDX-License-Identifier: EUPL-1.2 OR LicenseRef-CCLA-1.0
# SPDX-LicenseComment: This file is part of the CISS.debian.installer.secure framework.
# SPDX-PackageName: CISS.debian.installer
# SPDX-Security-Contact: security@coresecret.eu

guard_sourcing

#######################################
# Function to format the respective partition on each device according to the recipe string chosen.
# Globals:
#   DIR_LOG
#   HMP_PATH_FSUUID
#   VAR_RECIPE_STRING
#   VAR_SETUP_PART
# Arguments:
#   None
# Returns:
#   0: on success
#######################################
partition_formatting() {
  ### Declare Arrays and Variables.
  declare -Agx HMP_PATH_FSUUID
  declare var_dev var_part \
    var_encryption_enable var_encryption_label var_fs_btrfs_checksum var_fs_btrfs_compress var_fs_btrfs_dedup \
    var_fs_format var_fs_label var_fs_options var_fs_version var_mount_path var_node var_fs_uuid
  declare -a ary_devs ary_parts ary_opts ary_fmt_opts

  ### Iterate over all devices in the recipe.
  readarray -t ary_devs < <(yq e -r ".recipe.${VAR_RECIPE_STRING}.dev | keys | .[]" "${VAR_SETUP_PART}")
  for var_dev in "${ary_devs[@]}"; do

    ### Iterate over all partitions for this device.
    readarray -t ary_parts < <(yq e -r ".recipe.${VAR_RECIPE_STRING}.dev.${var_dev} | keys | .[]" "${VAR_SETUP_PART}")
    for var_part in "${ary_parts[@]}"; do

      ### Extract parameters from YAML.
      var_encryption_enable=$(yq_val ".recipe.${VAR_RECIPE_STRING}.dev.${var_dev}.${var_part}.encryption.enable"         "${VAR_SETUP_PART}")
      var_encryption_label=$(yq_val ".recipe.${VAR_RECIPE_STRING}.dev.${var_dev}.${var_part}.encryption.label"           "${VAR_SETUP_PART}")
      var_fs_btrfs_checksum=$(yq_val ".recipe.${VAR_RECIPE_STRING}.dev.${var_dev}.${var_part}.filesystem.btrfs.checksum" "${VAR_SETUP_PART}")
      var_fs_btrfs_compress=$(yq_val ".recipe.${VAR_RECIPE_STRING}.dev.${var_dev}.${var_part}.filesystem.btrfs.compress" "${VAR_SETUP_PART}")
      var_fs_btrfs_dedup=$(yq_val ".recipe.${VAR_RECIPE_STRING}.dev.${var_dev}.${var_part}.filesystem.btrfs.dedup"       "${VAR_SETUP_PART}")
      var_fs_format=$(yq_val ".recipe.${VAR_RECIPE_STRING}.dev.${var_dev}.${var_part}.filesystem.format"                 "${VAR_SETUP_PART}")
      var_fs_label=$(yq_val ".recipe.${VAR_RECIPE_STRING}.dev.${var_dev}.${var_part}.filesystem.label"                   "${VAR_SETUP_PART}")
      var_fs_options=$(yq_val ".recipe.${VAR_RECIPE_STRING}.dev.${var_dev}.${var_part}.filesystem.options"               "${VAR_SETUP_PART}")
      var_fs_version=$(yq_val ".recipe.${VAR_RECIPE_STRING}.dev.${var_dev}.${var_part}.filesystem.version"               "${VAR_SETUP_PART}")
      var_mount_path=$(yq_val ".recipe.${VAR_RECIPE_STRING}.dev.${var_dev}.${var_part}.mount.path"                       "${VAR_SETUP_PART}")

      [[ "${var_fs_format,,}" != "true" ]] && continue

      ### Preparation of Ephemeral 'SWAP' and '/tmp' as per https://wiki.archlinux.org/title/Dm-crypt/Swap_encryption#UUID_and_LABEL
      case "${var_mount_path,,}" in
        swap|/tmp)
            mkfs.ext4 -L "${var_fs_label}" "/dev/${var_dev}${var_part}" 1M
          do_log "info" "false" "Partition: '/dev/${var_dev}${var_part}' ephemeral encryption prepared for: '${var_mount_path}'."
          continue
          ;;
      esac

      if [[ "${var_encryption_enable,,}" == "true" ]]; then
        var_node="/dev/mapper/${var_encryption_label}"
      else
        var_node="/dev/${var_dev}${var_part}"
      fi

      case "${var_fs_version,,}" in

        btrfs)
          ary_opts=( -L "${var_fs_label}" -f --csum "${var_fs_btrfs_checksum}" -O compress="${var_fs_btrfs_compress}" )
          [[ "${var_fs_btrfs_dedup,,}" == "true" ]] && ary_opts+=( -m dup )
          mkfs.btrfs "${ary_opts[@]}" "${var_node}"
          do_log "info" "false" "Partition: '${var_node}' formatted: btrfs."
          echo "Partition: '${var_node}':" >> "${DIR_LOG}/btrfs.log"
          btrfs filesystem show "${var_node}" >> "${DIR_LOG}/btrfs.log"
          var_fs_uuid=$(blkid -s UUID -o value "${var_node}")
          HMP_PATH_FSUUID["UUID_${var_mount_path}"]="${var_fs_uuid}"
          ;;

        ext4)
          read -r -a ary_fmt_opts <<< "${var_fs_options}"
          mkfs.ext4 -L "${var_fs_label}" "${ary_fmt_opts[@]}" "${var_node}"
          do_log "info" "false" "Partition: '${var_node}' formatted: ext4."
          echo "Partition: '${var_node}':" >> "${DIR_LOG}/ext4.log"
          tune2fs -l "${var_node}" >> "${DIR_LOG}/ext4.log"
          var_fs_uuid=$(blkid -s UUID -o value "${var_node}")
          HMP_PATH_FSUUID["UUID_${var_mount_path}"]="${var_fs_uuid}"
          ;;

        fat32)
          mkfs.fat -F 32 -n "${var_fs_label}" "${var_node}"
          do_log "info" "false" "Partition: '${var_node}' formatted: FAT32."
          var_fs_uuid=$(blkid -s UUID -o value "${var_node}")
          HMP_PATH_FSUUID["UUID_${var_mount_path}"]="${var_fs_uuid}"
          ;;

        *)
          do_log "error" "false" "Unsupported filesystem format: '${var_fs_version}'."
          ;;

      esac

    done

  done
  return 0
}
# vim: number et ts=2 sw=2 sts=2 ai tw=128 ft=sh
